package guis;

import basics.BasicGuiApp;
import basics.BasicMod;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.AnchorPane;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import main.ModLoader;
import manager.ResourceManager;

public class MainGui extends AnchorPane{
	
	
	private static Text notificationText;
	public final TextField inputField;
	
	public MainGui(){
		
		this.setPrefWidth(400);
		this.setPrefHeight(60);
		this.setStyle("-fx-background-color: rgba(0, 0, 0, 0.8);");
		
		
		inputField = new TextField();
		inputField.setLayoutX(0);
		inputField.setLayoutY(0);
		inputField.setPrefWidth(370);
		inputField.setPrefHeight(60);
		inputField.requestFocus();
		inputField.setStyle("-fx-background-color: rgba(0, 0, 0, 0);"
				+ "-fx-text-inner-color: white;"
				+ "-fx-padding: 0px;"
				+ "-fx-border-insets: 0px;"
				+ "-fx-font-weight: bold"
				+ "-fx-background-insetts: 0px");
		inputField.setFont(ResourceManager.getFontBig());
		inputField.setOnKeyPressed(new EventHandler<KeyEvent>(){

				public void handle(KeyEvent event) {
					String input;
					if(event.getCode().name().equals("ENTER")){
						//TODO create a layout for suggestions of which maybe 5 can be displayed
						BasicGuiApp.mainStage.setAlwaysOnTop(false);
    					input = inputField.getText();
    					inputField.setText("");
    					if(input.equals("exit")){
    						System.exit(-1);
    					}
    					for (BasicMod bm : ModLoader.mods) {
							bm.checkInput(input);
    					}
    				}
				
				}
		});
	
	
		Button minimize = new Button("-");
		minimize.setPrefWidth(30);
		minimize.setPrefHeight(30);
		minimize.setLayoutX(370);
		minimize.setLayoutY(-10);
		minimize.setStyle("-fx-background-color: rgba(0, 0, 0, 0);"
				+ "-fx-text-inner-color: white;"
				+ "-fx-text-fill: white;");
		minimize.setFont(new Font("Arial", 25));
		minimize.setOnAction(new EventHandler<ActionEvent>() {
		
		
			public void handle(ActionEvent event) {
				BasicGuiApp.mainStage.setIconified(true);
			
			}
		});

		//TODO maybe show this only when notification is present
		//TODO Enlarge and collapse window if content is present
		notificationText = new Text();
		notificationText.setLayoutX(0);
		notificationText.setLayoutY(65);
		notificationText.prefWidth(400);
		notificationText.prefHeight(22);
		notificationText.setStyle("-fx-background-color: rgba(0, 0, 0, 0);"
				+ "-fx-fill: rgb(221,255,0);");
		notificationText.setFont(ResourceManager.getFontSmall());
		notificationText.setVisible(false);
		notificationText.setManaged(false);
	
		this.getChildren().add(inputField);
		this.getChildren().add(minimize);
		this.getChildren().add(notificationText);
	}
	
	
	public static void addNotification(String msg,final int sec){
		notificationText.setText(msg);
		notificationText.setManaged(true);
		notificationText.setVisible(true);
		BasicGuiApp.mainScene.getRoot().resize(400,60);
		BasicGuiApp.mainScene.getWindow().sizeToScene();
		Thread t = new Thread(() -> {
			try {
				Thread.sleep(sec*1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			notificationText.setText("");
			notificationText.setVisible(false);
			notificationText.setManaged(false);
			BasicGuiApp.mainScene.getRoot().resize(400,40);
			BasicGuiApp.mainScene.getWindow().sizeToScene();
		});
		t.start();
	}
}
