package guis;

import org.jnativehook.GlobalScreen;

import basics.BasicGuiApp;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.layout.AnchorPane;
import javafx.scene.text.Text;
import main.ShortcutKeyChecker;
import manager.OperatingSystem;
import manager.ResourceManager;
import manager.SettingManager;

public class SettingGui extends AnchorPane {

	AnchorPane settingPane;

	public SettingGui() {
		this.setPrefWidth(300);
		this.setPrefHeight(185);
		this.setStyle("-fx-background-color: rgba(240, 240, 240, 1);");

		/////////////////////////////////////////////////////////////////////////////
		Text setting1 = new Text("Load File.txt on startup:");
		setting1.setFont(ResourceManager.getFontSmall());
		setting1.setLayoutX(10);
		setting1.setLayoutY(20);
		setting1.prefWidth(170);
		setting1.prefHeight(30);

		final CheckBox setting1Box = new CheckBox();
		setting1Box.setLayoutX(180);
		setting1Box.setLayoutY(7);
		setting1Box.prefWidth(20);
		setting1Box.prefHeight(20);
		setting1Box.setSelected(SettingManager.isLoadFileOnBoot());
		///////////////////////////////////////////////////////////////////////////////
		/////////////////////////////////////////////////////////////////////////////////

		Text setting3 = new Text("Check for updates on startup:");
		setting3.setFont(ResourceManager.getFontSmall());
		setting3.setLayoutX(10);
		setting3.setLayoutY(100);
		setting3.prefWidth(220);
		setting3.prefHeight(30);

		final CheckBox setting3Box = new CheckBox();
		setting3Box.setLayoutX(230);
		setting3Box.setLayoutY(87);
		setting3Box.prefWidth(30);
		setting3Box.prefHeight(30);
		setting3Box.setSelected(SettingManager.isCheckUptdateOnBoot());

		Button exit = new Button("Done");
		exit.setFont(ResourceManager.getFontSmall());
		exit.setLayoutX(230);
		exit.setLayoutY(145);
		exit.prefWidth(50);
		exit.prefHeight(24);
		exit.setOnAction(new EventHandler<ActionEvent>() {

			public void handle(ActionEvent event) {
				SettingManager.setLoadFileOnBoot(setting1Box.isSelected());
				SettingManager.setCheckUptdateOnBoot(setting3Box.isSelected());
				SettingManager.saveSettings();
				BasicGuiApp.mainStage.setScene(BasicGuiApp.mainScene);

			}
		});

		this.getChildren().add(setting1);
		this.getChildren().add(setting1Box);
		this.getChildren().add(setting3);
		this.getChildren().add(setting3Box);

		this.getChildren().add(exit);
	}

}
