package manager;


import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.text.Font;

public class ResourceManager {
	
	private static Font fontBig = null;
	private static Font fontSmall = null;
	
	private static ImageView addImage = null;
	private static ImageView backImage = null;
	private static ImageView editImage = null;
	private static ImageView lockImage = null;
	private static ImageView saveImage = null;
	private static ImageView unsavedImage = null;
	private static ImageView trashImage = null;
	
	
	public static void loadResources() {
		fontBig = Font.loadFont(ResourceManager.class.getResourceAsStream("/LiberationSerif-Regular.ttf"), 40);
		fontSmall = Font.loadFont(ResourceManager.class.getResourceAsStream("/LiberationSerif-Regular.ttf"), 17);
		
		addImage = loadIcon("/plus.png");
		addImage.setFitWidth(32);
		addImage.setFitHeight(32);
		addImage.setPreserveRatio(true);
		
		backImage = loadIcon("/back.png");
		editImage = loadIcon("/edit.png");
		lockImage = loadIcon("/lock.png");
		saveImage = loadIcon("/save.png");
		unsavedImage = loadIcon("/unsaved.png");
		
		trashImage = loadIcon("/trash.png");
	}

	
	private static ImageView loadIcon(String path) {
		return new ImageView(new Image(ResourceManager.class.getResourceAsStream(path), 32, 32,true , false));
	}
	
	public static Font getFontBig() {
		return fontBig;
	}


	public static Font getFontSmall() {
		return fontSmall;
	}


	public static ImageView getAddImage() {
		return addImage;
	}
	
	public static ImageView getBackImage() {
		return backImage;
	}


	public static ImageView getEditImage() {
		return editImage;
	}


	public static ImageView getLockImage() {
		return lockImage;
	}

	public static ImageView getSaveImage() {
		return saveImage;
	}
	
	public static ImageView getSaveImageUnsaved() {
		return unsavedImage;
	}



	public static ImageView getTrashImage() {
		return trashImage;
	}



	



}