package mod_quicklaunch;

import javafx.scene.control.TextArea;
import javafx.scene.layout.AnchorPane;

public class HelpWindow extends AnchorPane{
	
	private TextArea shortcuts;
	private TextArea description;
	private final int WINDOW_WIDTH = 500;
	private final int WINDOW_HEIGHT = 230;

	public HelpWindow() {
		
		this.setPrefSize(WINDOW_WIDTH, WINDOW_HEIGHT);
		
		
		shortcuts = new TextArea();
		shortcuts.setText("Shortcuts:\n/c\n/cos\n/cu\n/x | exit\n\n/? | help\n/lf\n/s\n/sf\n\nany shortcut");
		shortcuts.setPrefSize(WINDOW_WIDTH/5, WINDOW_HEIGHT+10);
		shortcuts.setLayoutX(-5);
		shortcuts.setLayoutY(-5);
		shortcuts.setEditable(false);
		shortcuts.setStyle("-fx-focus-color: transparent; -fx-faint-focus-color: white");
		
		description = new TextArea();
		description.setPrefSize(WINDOW_WIDTH/5*4, WINDOW_HEIGHT+10);
		description.setLayoutX(WINDOW_WIDTH/5);
		description.setLayoutY(-5);
		description.setEditable(false);
		description.setStyle("-fx-focus-color: transparent ; -fx-faint-focus-color: white");
		description.setText("Description:\n"
				+ "Settings UI\n"
				+ "(Re)center QuickLaunch on screen\n"
				+ "Check for updates\n"          
				+ "Kills the whole program instantly\n"
				+ "(If you changed something make sure it is already saved)\n"
				+ "Show this help dialog\n"
				+ "Load the shortcuts from the hard drive\n"
				+ "Open shortcut manager\n"
				+ "Save current shortcuts to hard drive\n"
				+ "(Overrides existing shortcuts)\n"
				+ "executes the program linked to the shortcut\n"
				+ "(Visit /s for all your personal shortcuts)");
		
		
		
		this.getChildren().add(description);
		this.getChildren().add(shortcuts);
		this.requestFocus();
	}

}
